//---------------------------------------------------------------------------

#include <vcl.h>
#include "ITSSkinF.h"
#include "ITSUtilF.h"
#include "AppGlobalF.h"
#include "CDSItsRoadInfoF.h"
#include "ITSLangTransF.h"
#pragma hdrstop

#include "IHS0060MF.h"
#include "IHS00601F.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "FRAME_ItsRoadF"
#pragma link "cxButtons"
#pragma link "cxCalendar"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxGraphics"
#pragma link "cxGroupBox"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxPC"
#pragma link "cxPCdxBarPopupMenu"
#pragma link "cxSpinEdit"
#pragma link "cxSplitter"
#pragma link "cxTextEdit"
#pragma link "cxTimeEdit"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma resource "*.dfm"

TIHS0060M *IHS0060M = NULL;
//---------------------------------------------------------------------------
__fastcall TIHS0060M::TIHS0060M(TComponent* Owner)
    : TForm(Owner)
{
    LangTrans->Translate(this, ITSDb_GetConnection());
    FTitle = Caption;//"수집데이터 분석";

    ITSSkin_Load(this);
    CMM_LoadForm(g_sFormsDir, this);

    m_pFormList = new TList();
    TsList01->TabVisible = false;

    //FRAMELinkList1->PnlTop->Visible = false;
    //FRAMELinkList1->PnlBottom->Visible = false;
    if (!RLinkManager)
    {
        RLinkManager = new TRLinkManager();
        RLinkManager->LoadSido();
        RLinkManager->LoadRoad();
        RLinkManager->LoadLink();
    }
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::CommClose()
{
    try
    {
        for (int idx = m_pFormList->Count-1; idx >= 0; idx--)
        {
            m_pFormList->Delete(idx);
        }
        delete m_pFormList;

        CMM_SaveForm(g_sFormsDir, this);
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::FormShow(TObject *Sender)
{
    Refresh();
    FormInit();
    TmrShow->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::FormInit()
{
    DtStDate->Date = Now() - 1;
    DtEdDate->Date = Now() - 1;
    //DtStTime->EditValue = Now().FormatString("hh");
    //DtEdTime->EditValue = Now().FormatString("hh");
    DtStTime->Time = StrToDateTime("00:00");
    DtEdTime->Time = StrToDateTime("23:59");
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::TmrShowTimer(TObject *Sender)
{
    TmrShow->Enabled = false;

    //FRAMELinkList1->UpdateList();
    FRAMEItsRoad1->InitFilter(true);
    FRAMEItsRoad1->InitItsRoad();
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::RefreshData()
{
    // 검색조건에 의한 링크 데이터 조회
    try
    {
        //SelListData();
	}
	__finally
	{
	}
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::BtnSearchClick(TObject *Sender)
{
    Application->ProcessMessages();
    TSqlCursor sqlCrs((TControl*)BtnSearch);

#if 0
	FStDateTime = DtStDate->Date.FormatString("yyyymmdd") + DtStTime->Time.FormatString("hh");
	FEdDateTime = DtEdDate->Date.FormatString("yyyymmdd") + DtEdTime->Time.FormatString("hh");
#else
	FStDateTime = DtStDate->Date.FormatString("yyyymmdd") + DtStTime->Time.FormatString("hhnn");
	FEdDateTime = DtEdDate->Date.FormatString("yyyymmdd") + DtEdTime->Time.FormatString("hhnn");
#endif
    if (FStDateTime > FEdDateTime)
    {
        Application->MessageBox(FrmLang->lblQryDtErr->Caption.c_str(),//L"검색 시작시각이 검색 종료시각 보다 큽니다.",
                                FTitle.c_str(), MB_OK|MB_ICONWARNING|MB_APPLMODAL);
        ActiveControl = DtStDate;
        return;
    }
#if 0
    FStDateTime = FStDateTime + "0000";
    FEdDateTime = FEdDateTime + "5959";
#else
    FStDateTime = FStDateTime + "00";
    FEdDateTime = FEdDateTime + "59";
#endif

    FIdList = "";
#if 0
    int nSelects = FRAMELinkList1->GetSelLinkIds(FIdList);
    if (0 == nSelects)
    {
        Application->MessageBox(FrmLang->lblSelLstErr->Caption.c_str(),//L"검색 목록을 선택하지 않았습니다.",
                                FTitle.c_str(), MB_OK|MB_ICONWARNING|MB_APPLMODAL);
        FRAMELinkList1->CxList->SetFocus();
        return;
    }
#endif
    STCodeCondition m_CrossCond;
	FRAMEItsRoad1->GetCondition(m_CrossCond);
    String sWhere = m_CrossCond.ToSQLInString("A.LINK_ID");
    FIdList = sWhere;

    #if 0
    String sTitle = "[" + FStDateTime + "-" + FEdDateTime + "]";
#else
    String sTitle = FRAMEItsRoad1->FSelNm;
#endif
    try
    {
        Application->ProcessMessages();
        LockWindowUpdate(Handle);

        TcxTabSheet *pSheet = CMM_AddTabSheet(PgTab, sTitle);
        if (!pSheet) return;

        IHS00601 = new TIHS00601(this, Handle, FStDateTime, FEdDateTime, FIdList);
        IHS00601->Parent = pSheet;
        IHS00601->Show();
        PgTab->ActivePage = pSheet;
        pSheet = PgTab->ActivePage;
        m_pFormList->Add(IHS00601);
    }
    __finally
    {
        LockWindowUpdate(0);
    }
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::BtnCloseClick(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::OnSubFormClose(TMessage Msg)
{
    int nActiveIdx = PgTab->ActivePageIndex;
    if (nActiveIdx <= 0) return;

    LockWindowUpdate(Handle);

    TcxTabSheet *pSheet = PgTab->ActivePage;
    if (pSheet)
    {
        delete pSheet;
    }
    nActiveIdx--;   // 첫번째 탭은 화면에 숨겨져 있다.
    m_pFormList->Delete(nActiveIdx);

    LockWindowUpdate(0);
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::PgTabDblClick(TObject *Sender)
{
    TPoint APoint;
    APoint = PgTab->MouseDownPos;
    if (PgTab->IndexOfTabAt(APoint.x, APoint.y) != -1)
        POST_MSG(Handle, WM_SUBFORM_CLOSE, 0, 0);
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::FormClose(TObject *Sender, TCloseAction &Action)
{
    CommClose();
    IHS0060M = NULL;
    Action = caFree;    
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::btnFilterClick(TObject *Sender)
{
    String sFilter = EdFilter->Text.Trim();
    FRAMEItsRoad1->FilterItsRoad(sFilter);
    //fnUpdateConditionHtmlState();
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::EdFilterKeyPress(TObject *Sender, wchar_t &Key)
{
	if (VK_RETURN == Key)
	{
        btnFilterClick(NULL);
	}
}
//---------------------------------------------------------------------------

void __fastcall TIHS0060M::PgTabCanCloseEx(TObject *Sender, int ATabIndex, bool &ACanClose)
{
    int nActiveIdx = ATabIndex;
    if (nActiveIdx <= 0) return;

    nActiveIdx--;   // 첫번째 탭은 화면에 숨겨져 있다.
    m_pFormList->Delete(nActiveIdx);
}
//---------------------------------------------------------------------------

